diff --git a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
index 534e8f367..f6847acde 100644
--- a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
@@ -57,7 +57,7 @@ public class LightingEngineLegacy implements LightingEngine {
 
     @Override
     public void scheduleLightingUpdate(final LightLayer layer, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
-        if(this.world.worldType.hasCeiling() && layer == LightLayer.Sky)
+        if(this.world.getWorldType().hasCeiling() && layer == LightLayer.Sky)
         {
             return;
         }
@@ -276,7 +276,7 @@ public class LightingEngineLegacy implements LightingEngine {
 
         private static void neighborLightPropagationChanged(final LightingEngine lightingEngine, final World world, final LightLayer lightLayer, final int x, final int y, final int z, int lightValue)
         {
-            if(world.worldType.hasCeiling() && lightLayer == LightLayer.Sky)
+            if(world.getWorldType().hasCeiling() && lightLayer == LightLayer.Sky)
             {
                 return;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
index 8fbb56fd2..102c2c9f1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
@@ -152,6 +152,12 @@ public final class ChunkPos implements Externalizable, Cloneable, ChunkPosc {
         return this;
     }
 
+    public @NotNull ChunkPos set(final @NotNull ChunkPosc chunkPos) {
+        this.x = chunkPos.x();
+        this.z = chunkPos.z();
+        return this;
+    }
+
     public @NotNull ChunkPos set(@NotNull TilePosc pos) {
         return set(Math.floorDiv(pos.x(), Chunk.CHUNK_SIZE_X), Math.floorDiv(pos.z(), Chunk.CHUNK_SIZE_Z));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
index 76d24531b..ada53f8b5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.save;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.ByteTag;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
@@ -7,148 +8,117 @@ import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypeGroups;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.io.File;
 import java.io.IOException;
 import java.nio.file.Files;
 import java.util.Objects;
 
-public class DimensionData
-{
-    private @NotNull String worldType;
-    private int weatherCurrentId = -1;
-    private int weatherNextId = -1;
-    private long weatherDuration;
-    private float weatherIntensity;
-    private float weatherPower;
+public class DimensionData {
+    private static final Logger LOGGER = LogUtils.getLogger();
 
-    public DimensionData(CompoundTag tag)
-    {
-        readFromNBTTag(tag);
-    }
+    public static @NotNull DimensionData fromCompoundTag(final @NotNull CompoundTag tag, final @NotNull Dimension dimension) {
+        @Nullable WorldType worldType = Registries.WORLD_TYPES.getItem(tag.getString("WorldType"));
+        if (worldType == null) {
+            worldType = WorldTypeGroups.DEFAULT.get(dimension);
+        }
 
-    public DimensionData(WorldType worldType)
-    {
-        this.worldType = Registries.WORLD_TYPES.getKey(worldType);
+        final @NotNull DimensionData dimensionData = new DimensionData(worldType);
+
+        final @NotNull CompoundTag weatherTag = tag.getCompound("Weather");
+        dimensionData.weatherCurrentId = weatherTag.getInteger("CurrentID");
+        dimensionData.weatherNextId = weatherTag.getInteger("NextID");
+        dimensionData.weatherDuration = weatherTag.getLong("Duration");
+        dimensionData.weatherIntensity = weatherTag.getFloat("Intensity");
+        dimensionData.weatherPower = weatherTag.getFloat("Power");
+
+        return dimensionData;
     }
 
-    public DimensionData(DimensionData dimensionData)
-    {
-        worldType = dimensionData.worldType;
-        weatherCurrentId = dimensionData.weatherCurrentId;
-        weatherNextId = dimensionData.weatherNextId;
-        weatherDuration = dimensionData.weatherDuration;
-        weatherIntensity = dimensionData.weatherIntensity;
-        weatherPower = dimensionData.weatherPower;
+    public static @NotNull CompoundTag toCompoundTag(final @NotNull DimensionData dimensionData, final @NotNull CompoundTag out) {
+        out.putString("WorldType", Objects.requireNonNull(Registries.WORLD_TYPES.getKey(dimensionData.worldType)));
+
+        final @NotNull CompoundTag weatherTag = new CompoundTag();
+        weatherTag.putInt("CurrentID", dimensionData.weatherCurrentId);
+        weatherTag.putInt("NextID", dimensionData.weatherNextId);
+        weatherTag.putLong("Duration", dimensionData.weatherDuration);
+        weatherTag.putFloat("Intensity", dimensionData.weatherIntensity);
+        weatherTag.putFloat("Power", dimensionData.weatherPower);
+
+        out.putCompound("Weather", weatherTag);
+
+        return out;
     }
 
-    public DimensionData(File worldDir, Dimension dimension)
-        throws IOException
-    {
-        CompoundTag nbtRootData = null;
-        File dimensionsDir = new File(worldDir, "dimensions");
-        File dimensionDir = new File(dimensionsDir, "" + dimension.id);
+    public static @NotNull DimensionData fromWorldDir(final @NotNull File worldDir, final @NotNull Dimension dimension) throws IOException {
+        @Nullable CompoundTag nbtRootData = null;
+        final @NotNull File dimensionsDir = new File(worldDir, "dimensions");
+        final @NotNull File dimensionDir = new File(dimensionsDir, "" + dimension.id);
 
-        if (!worldDir.exists() || !dimensionsDir.exists() || !dimensionDir.exists())
-        {
+        if (!worldDir.exists() || !dimensionsDir.exists() || !dimensionDir.exists()) {
             throw new IOException();
         }
-        File dimensionDat = new File(dimensionDir, "dimension.dat");
-        if (dimensionDat.exists())
-        {
-            CompoundTag nbtRoot = NbtIo.readCompressed((Files.newInputStream(dimensionDat.toPath())));
+        @NotNull File dimensionDat = new File(dimensionDir, "dimension.dat");
+        if (dimensionDat.exists()) {
+            final @NotNull CompoundTag nbtRoot = NbtIo.readCompressed((Files.newInputStream(dimensionDat.toPath())));
             nbtRootData = nbtRoot.getCompound("Data");
-        }
-        else
-        {
+        } else {
             dimensionDat = new File(dimensionDir, "dimension.dat_old");
-            if (dimensionDat.exists())
-            {
-                CompoundTag oldNbtRoot = NbtIo.readCompressed(Files.newInputStream(dimensionDat.toPath()));
+            if (dimensionDat.exists()) {
+                final @NotNull CompoundTag oldNbtRoot = NbtIo.readCompressed(Files.newInputStream(dimensionDat.toPath()));
                 nbtRootData = oldNbtRoot.getCompound("Data");
             }
         }
 
-        if (nbtRootData != null)
-        {
-            readFromNBTTag(nbtRootData);
-        }
-        else
-        {
+        if (nbtRootData != null) {
+            return DimensionData.fromCompoundTag(nbtRootData, dimension);
+        } else {
             throw new IOException();
         }
     }
 
-    public CompoundTag toNBTTag()
-    {
-        CompoundTag tag = new CompoundTag();
-        writeToNBTTag(tag);
-        return tag;
-    }
-
-    private void writeToNBTTag(CompoundTag dimTag)
-    {
-        dimTag.putString("WorldType", worldType);
-        CompoundTag weatherTag = new CompoundTag();
-        weatherTag.putInt("CurrentID", weatherCurrentId);
-        weatherTag.putInt("NextID", weatherNextId);
-        weatherTag.putLong("Duration", weatherDuration);
-        weatherTag.putFloat("Intensity", weatherIntensity);
-        weatherTag.putFloat("Power", weatherPower);
-        dimTag.putCompound("Weather", weatherTag);
-    }
-
-    private void readFromNBTTag(CompoundTag dimTag)
-    {
-        if (dimTag.getTag("WorldType") instanceof ByteTag)
-        {
-            // This is entirely to fix world types from worlds created during the prerelease period of 1.7.7.0, which used a byte ID the same as previous versions of BTA.
-            // This should be removed at some appropriate point in the future, such as 1.7.7.1.
-            WorldType legacyWorldType = LegacyWorldTypes.getWorldTypeById(dimTag.getByte("WorldType"));
-            if (legacyWorldType == null)
-            {
-                legacyWorldType = WorldTypes.OVERWORLD_EXTENDED;
-            }
+    private final @NotNull WorldType worldType;
+    private int weatherCurrentId = -1;
+    private int weatherNextId = -1;
+    private long weatherDuration;
+    private float weatherIntensity;
+    private float weatherPower;
 
-            worldType = Registries.WORLD_TYPES.getKey(legacyWorldType);
-        }
-        else
-        {
-            worldType = dimTag.getString("WorldType");
-        }
-        CompoundTag weatherTag = dimTag.getCompound("Weather");
-        weatherCurrentId = weatherTag.getInteger("CurrentID");
-        weatherNextId = weatherTag.getInteger("NextID");
-        weatherDuration = weatherTag.getLong("Duration");
-        weatherIntensity = weatherTag.getFloat("Intensity");
-        weatherPower = weatherTag.getFloat("Power");
+    public DimensionData(
+        final @NotNull WorldType worldType
+    ) {
+        this.worldType = worldType;
     }
 
-    public @NotNull WorldType getWorldType()
-    {
-        return Objects.requireNonNull(Registries.WORLD_TYPES.getItem(this.worldType));
+    public DimensionData(final @NotNull DimensionData dimensionData) {
+        this(dimensionData.worldType);
+
+        this.weatherCurrentId = dimensionData.weatherCurrentId;
+        this.weatherNextId = dimensionData.weatherNextId;
+        this.weatherDuration = dimensionData.weatherDuration;
+        this.weatherIntensity = dimensionData.weatherIntensity;
+        this.weatherPower = dimensionData.weatherPower;
     }
 
-    public void setWorldType(WorldType type)
-    {
-        this.worldType = Registries.WORLD_TYPES.getKey(type);
+    public @NotNull WorldType getWorldType() {
+        return this.worldType;
     }
 
-    public Weather getCurrentWeather()
-    {
-        if (weatherCurrentId < 0) {
+    public @Nullable Weather getCurrentWeather() {
+        if (this.weatherCurrentId < 0) {
             return null;
         }
-        return Weathers.getWeather(weatherCurrentId);
+        return Weathers.getWeather(this.weatherCurrentId);
     }
 
-    public void setCurrentWeather(@Nullable Weather weather)
-    {
+    public void setCurrentWeather(final @Nullable Weather weather) {
         if (weather == null) {
             this.weatherCurrentId = -1;
         } else {
@@ -156,51 +126,40 @@ public class DimensionData
         }
     }
 
-    public @Nullable Weather getNextWeather()
-    {
-        if (weatherNextId == -1) return null;
-        return Weathers.getWeather(weatherNextId);
+    public @Nullable Weather getNextWeather() {
+        if (this.weatherNextId == -1) return null;
+        return Weathers.getWeather(this.weatherNextId);
     }
 
-    public void setNextWeather(@Nullable Weather weather)
-    {
-        if (weather == null)
-        {
+    public void setNextWeather(final @Nullable Weather weather) {
+        if (weather == null) {
             this.weatherNextId = -1;
-        }
-        else
-        {
+        } else {
             this.weatherNextId = weather.getId();
         }
     }
 
-    public long getWeatherDuration()
-    {
-        return weatherDuration;
+    public long getWeatherDuration() {
+        return this.weatherDuration;
     }
 
-    public void setWeatherDuration(long duration)
-    {
+    public void setWeatherDuration(final long duration) {
         this.weatherDuration = duration;
     }
 
-    public float getWeatherIntensity()
-    {
-        return weatherIntensity;
+    public float getWeatherIntensity() {
+        return this.weatherIntensity;
     }
 
-    public void setWeatherIntensity(float intensity)
-    {
+    public void setWeatherIntensity(final float intensity) {
         this.weatherIntensity = intensity;
     }
 
-    public float getWeatherPower()
-    {
-        return weatherPower;
+    public float getWeatherPower() {
+        return this.weatherPower;
     }
 
-    public void setWeatherPower(float power)
-    {
+    public void setWeatherPower(final float power) {
         this.weatherPower = power;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java b/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
index 1ef4e0acc..2e34508b0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.save;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.Dimension;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.File;
 import java.util.List;
@@ -59,18 +60,18 @@ public interface ISaveFormat
     /**
      * Fetches the dimension data for a given world.
      * @param worldDirName The name of the directory containing the world data.
-     * @param dimensionId The ID of the dimension to read.
+     * @param dimension The dimension to read.
      * @return The loaded dimension data for the requested dimension.
      */
-    DimensionData getDimensionData(String worldDirName, int dimensionId);
+    DimensionData getDimensionData(@NotNull String worldDirName, @NotNull Dimension dimension);
 
     /**
      * Fetches the dimension data for a given world as raw NBT.
      * @param worldDirName The name of the directory
-     * @param dimensionId The ID of the dimension to read.
+     * @param dimension The dimension to read.
      * @return The loaded dimension data for the requested dimension.
      */
-    CompoundTag getDimensionDataRaw(String worldDirName, int dimensionId);
+    CompoundTag getDimensionDataRaw(@NotNull String worldDirName, @NotNull Dimension dimension);
 
     /**
      * Deletes a given world.
